module Fact where

import Foreign.C.String


----------------------------------------------------

fact :: Integer -> Integer
fact 0 = 1
fact n = n*(fact (n-1))

----------------------------------------------------

foreign export ccall factHS :: Int -> IO Int

factHS :: Int -> IO Int
factHS n = return (fromInteger (fact (toInteger n)))

----------------------------------------------------

foreign export ccall factHSstr :: Int -> IO CString

factHSstr :: Int -> IO CString
factHSstr n = newCString (show (fact (toInteger n)))

