/*
**  Listas Ligadas em C
**
**  Implementation Module
*/

#include <stdio.h>

#include "listas_int.h"

boolean Vazia( LISTA l )
{  if(l==NULL)
     return(TRUE);
   else return(FALSE);
}

boolean Pertence( int x, LISTA l )
{ if(Vazia(l)) return(FALSE);
  else
    if(l->elem == x) return(TRUE);
    else return(Pertence(x,l->next));
}

LISTA Ins( int x, LISTA l)
{ LISTA aux;

  aux = (LISTA)malloc(sizeof(celula));
  aux->elem = x;
  aux->next = l;
  return(aux);
}

LISTA InsOrd( int x, LISTA l)
{ LISTA aux;

  if  (Vazia(l) || (x < l->elem))
    { aux = (LISTA)malloc(sizeof(celula));
      aux->elem = x;
      aux->next = l;
      return(aux);
    }
  else
    { l->next = InsOrd(x,l->next);
      return(l);
    }
}

/* head is a partial function */
int Prim( LISTA l )
{ if(!Vazia(l)) return(l->elem);
  else fprintf(stderr,"Empty list\n");
}

LISTA Rem( int x, LISTA l )
{ LISTA aux;

  if(!Vazia(l))
    if(x==l->elem)
      { aux = l->next;
        free(l);
        return(aux);
      }
    else

      { l->next = Rem( x, l->next );
        return(l);
      }
  else return l;
} 


void List( LISTA l )
{ if(!Vazia(l))
  { printf("%d   ", l->elem);
    List(l->next);
  }
}

int Comp (LISTA l)
{
  if (Vazia(l))
    return 0;
  else
    return (1 + Comp(l->next));
}


int length (LISTA l , int s)
{ return (l == NULL) ? s : length(l->next,s+1); }


int Soma (LISTA l)
{
   if (Vazia(l))
      return 0;
    else
      return (l->elem + Soma(l->next));
}

int Soma_iter (LISTA l)
{
  LISTA aux;
  int soma = 0;

  if (Vazia(l))
    return 0;
  else
     {
       for (aux = l ; aux != NULL ; aux = aux->next)
          soma += aux->elem;
       return soma;
     }
}


float Media(LISTA l)
{
   return ((float) Soma(l) / Comp (l));
}

LISTA inverte (LISTA l)
{
  LISTA aux = NULL;
      
  while (l != NULL)
    {  aux = Ins (l->elem,aux);
       l = l->next;
    }
  return (aux);
}     
   



