#include <stdio.h>
#include <stdlib.h>
#include "HsFFI.h"

#ifdef __GLASGOW_HASKELL__
#include "Fact_stub.h"
#endif

#ifdef __GLASGOW_HASKELL__
extern void __stginit_Fact ( void );
#endif

int main(int argc, char *argv[])
{
  int i;

  hs_init(&argc, &argv);
#ifdef __GLASGOW_HASKELL__
  hs_add_root(__stginit_Fact);
#endif

  for (i = 0; i < 15; i++) {
    char *hsStr;
    hsStr = factHSstr(i);
    printf("fact(%d)=%d [%s]\n", i, factHS(i), hsStr);
    free(hsStr);
  }


  hs_exit();
  return 0;
}
